using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Threading;
using System.IO;
using System.Net;
using Microsoft.Win32;

namespace HttpPingService
{
	public class HttpPingService : System.ServiceProcess.ServiceBase
	{
		Timer timer;

		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public HttpPingService()
		{
			// ̌ĂяóAWindows.Forms R|[lg fUCiŕKvłB
			InitializeComponent();

			// TODO: InitComponent ĂяǒɏǉĂB
		}

		// ̃C Gg |CgłB
		static void Main()
		{
			System.ServiceProcess.ServiceBase[] ServicesToRun;
	
			// 2 ȏ NT T[rX𓯂Ŏsł܂Bʂ̃T[rX
			// ̏ɒǉɂ́Aȉ̍sύX
			// 2 Ԗڂ̃T[rX IuWFNg쐬ĂB :
			//
			//   ServicesToRun = New System.ServiceProcess.ServiceBase[] {new Service1(), new MySecondUserService()};
			//
			ServicesToRun = new System.ServiceProcess.ServiceBase[] { new HttpPingService() };

			System.ServiceProcess.ServiceBase.Run(ServicesToRun);
		}

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// HttpPingService
			// 
			this.ServiceName = "HttpPingService";

		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// 삪؂ȂsAT[rX̎sWȂ悤ɐݒ肵܂B
		/// </summary>
		protected override void OnStart(string[] args)
		{
			RegistryKey regHttpPingService = Registry.LocalMachine.OpenSubKey("Software\\JomoraWorkShop\\HttpPingService");
			string url = null;
			int interval = 0;

			url = regHttpPingService.GetValue("url") as string;
			try 
			{
				url = new Uri(url).AbsoluteUri;
				interval = (int)regHttpPingService.GetValue("interval");
			} 
			catch (NullReferenceException nre) 
			{
				throw new NullReferenceException("WXglݒ肳Ă܂B", nre);
			}
			if (url == null || !url.StartsWith("http://") || interval < 1)
			{
				throw new NullReferenceException("WXglݒ肳Ă܂B");
			}

			// Create the delegate that invokes methods for the timer.
			TimerCallback timerDelegate = new TimerCallback(ping);

			// Create a timer that waits one second, then invokes every second.
			timer = new Timer(timerDelegate, url, 10000, interval * 60 * 1000);

		}
 
		/// <summary>
		/// ̃T[rX~܂B
		/// </summary>
		protected override void OnStop()
		{
			if (timer != null) {
				timer.Dispose();
			}
		}

		/*
		protected static void main(Object state) {
			string beforeIP = getIP();
			ping(state);
			string afterIP = getIP();

			if (beforeIP != afterIP) {
				//EventLogIuWFNg̍쐬
				EventLog elog = new EventLog();
				//Rs[^ݒ肷
				elog.MachineName = ".";
				//O̖Oݒ肷
				elog.Log = "DDNS";
				//\[Xݒ肷
				elog.Source = "HttpPingService";
				//CxgOɏ
				elog.WriteEntry("DDNSIPAhXύX܂B " + beforeIP + " -> " + afterIP);
			}
		}
		*/

		protected static void ping(Object state) {
			string url = state as string;
			HttpWebRequest req = WebRequest.Create(url) as HttpWebRequest;
			using (HttpWebResponse res = req.GetResponse() as HttpWebResponse) {
				//string contentType = res.ContentType;
				System.Reflection.Assembly asmby = System.Reflection.Assembly.GetExecutingAssembly();
				string logfile = System.IO.Path.GetDirectoryName(asmby.Location) + @"\HttpPing_log.htm";
				using (Stream st = res.GetResponseStream())
				/*
				using (FileStream fs = new FileStream(logfile, FileMode.Create)) {
					int b;
					while ((b = st.ReadByte()) != -1) {
						fs.WriteByte((byte)b);
					}
				}
				*/
				using (System.IO.StreamReader sr = new System.IO.StreamReader(st, System.Text.Encoding.Default)) {
					string html = sr.ReadToEnd();

					int sIndex = html.IndexOf("IPAhX ");
					if (sIndex != -1) {
						//IPAhXύXĂꍇ

						int eIndex = html.IndexOf("<br>", sIndex);
						//EventLogIuWFNg̍쐬
						EventLog elog = new EventLog();
						//Rs[^ݒ肷
						elog.MachineName = ".";
						//O̖Oݒ肷
						//elog.Log = "DDNS";
						//\[Xݒ肷
						elog.Source = "HttpPingService";
						//CxgOɏ
						elog.WriteEntry(html.Substring(sIndex, eIndex - sIndex), EventLogEntryType.Information, 123);
					}
				}
			}
		}
		
		/*
		protected static string getIP() {
			string ip = "";
			try {
				string url = "http://www.dyndns.org/cgi-bin/check_ip.cgi";
				HttpWebRequest req = WebRequest.Create(url) as HttpWebRequest;
				using (HttpWebResponse res = req.GetResponse() as HttpWebResponse) 
				using (Stream st = res.GetResponseStream())
				using (System.IO.StreamReader sr = new System.IO.StreamReader(st)) {
					string html = sr.ReadToEnd();
					int sIndex = html.IndexOf(": ") + 2;
					int eIndex = html.IndexOf("<!", sIndex);
					ip = html.Substring(sIndex, eIndex - sIndex);
				}
			} catch (Exception e) {
				EventLog.WriteEntry(e.Source, e.Message, EventLogEntryType.Warning);
			}
			return ip;
		}
		*/

	}

}
